require_relative "search_pi/version"
require 'bigdecimal/math'

module SearchPi
  include BigMath

  def pi(precision)
    BigDecimal(PI(precision))
  end

  def find(number, pattern)
    source     = number.to_s
    regex      = Regexp.new pattern.to_s
    match_pos  = source.index regex
    return nil if match_pos.nil?
    pre_match  = source[( (match_pos - 10) >= 0 ? (match_pos - 10) : 0 )..(match_pos-1)]
    post_match = source[(match_pos + pattern.to_s.size + 1)..(match_pos + pattern.to_s.size + 11)]
    {pre_match: pre_match,
     match_pos: match_pos,
     post_match: post_match,
     match: pattern}
  end
end